<?php
/*
Plugin Name: bbPress Adsense Injection
Plugin URI: http://www.2diabolos.com/blog/
Description: Inserts Adsense into your forum with plenty of options.
Version: 1.0
Author: Thierry BOTTARO
Author URI: http://www.2diabolos.com/blog

TODO : allow ads in odd and even posts with "alt" color ...

*/

add_action('bb_admin_menu_generator', 'bbai_add_options');

function bbai_add_options(){
	global $bb_submenu;
	$bb_submenu['themes.php'][] = array(__('Ads-injections'), 'use_keys', 'bbai_options_subpanel');
}


switch($_POST['action']){
case 'Save':

  bb_update_option('ai_network', $_POST['ai_network']);

  if(isset($_POST['betatest'])) bb_update_option('ai_betatest', "yes");
  else bb_delete_option('ai_betatest');
  if(isset($_POST['notme'])) bb_update_option('ai_notme', "yes");
  else bb_delete_option('ai_notme');
  if(isset($_POST['googtestmode'])) bb_update_option('ai_googtestmode', "yes");
  else bb_delete_option('ai_googtestmode');
  
  if(isset($_POST['dontshowinstr'])) bb_update_option('ai_dontshowinstr', "yes");
  
  bb_update_option('ai_color_border', $_POST['ai_color_border']);
  bb_update_option('ai_color_link', $_POST['ai_color_link']);
  bb_update_option('ai_color_bg', $_POST['ai_color_bg']);
  bb_update_option('ai_color_text', $_POST['ai_color_text']);
  bb_update_option('ai_color_url', $_POST['ai_color_url']);

  bb_update_option('ai_lra', $_POST['ai_pos']);
  bb_update_option('ai_nads', $_POST['nads']);
  bb_update_option('ai_text_only', false);

  bb_update_option('ai_client', $_POST['ai_client']);
  bb_update_option('ai_channel', $_POST['ai_channel']);
  bb_update_option('ai_client_ypn', $_POST['ai_client_ypn']);
  bb_update_option('ai_channel_ypn', $_POST['ai_channel_ypn']);
  
  if($_POST['234x60'] == "on") bb_update_option('ai_234x60', "checked=on");
  else bb_update_option('ai_234x60', "");
  if($_POST['200x200'] == "on") bb_update_option('ai_200x200', "checked=on");
  else bb_update_option('ai_200x200', "");
  if($_POST['125x125'] == "on") bb_update_option('ai_125x125', "checked=on");
  else bb_update_option('ai_125x125', "");
  if($_POST['180x150'] == "on") bb_update_option('ai_180x150', "checked=on");
  else bb_update_option('ai_180x150', "");
  if($_POST['120x240'] == "on") bb_update_option('ai_120x240', "checked=on");
  else bb_update_option('ai_120x240', "");
  if($_POST['300x250'] == "on") bb_update_option('ai_300x250', "checked=on");
  else bb_update_option('ai_300x250', "");
  if($_POST['250x250'] == "on") bb_update_option('ai_250x250', "checked=on");
  else bb_update_option('ai_250x250', "");
  if($_POST['336x280'] == "on") bb_update_option('ai_336x280', "checked=on");
  else bb_update_option('ai_336x280', "");
  if($_POST['468x60'] == "on") bb_update_option('ai_468x60', "checked=on");
  else bb_update_option('ai_468x60', "");

  break;
}

function bbai_options_subpanel(){
  if(bb_get_option("ai_network", "") == "")
    bb_update_option("ai_network", "Adsense");

  $ad_client = bb_get_option('ai_client');
  $ad_channel = bb_get_option('ai_channel');
  $ad_client_ypn = bb_get_option('ai_client_ypn');
  $ad_channel_ypn = bb_get_option('ai_channel_ypn');
  $adnetwork = bb_get_option("ai_network", "Adsense");

  $lra = bb_get_option('ai_lra');
  $nads = bb_get_option('ai_nads');
  $text_only = bb_get_option('ai_text_only');

  $ai_color_border = bb_get_option('ai_color_border');
  $ai_color_link = bb_get_option('ai_color_link');
  $ai_color_bg = bb_get_option('ai_color_bg');
  $ai_color_text = bb_get_option('ai_color_text');
  $ai_color_url = bb_get_option('ai_color_url');
  
?>
<div class="wrap"> 
  <h2><?php _e('Adsense Injection!', 'wpai') ?></h2> 
  <form name="form1" method="post">
	<input type="hidden" name="stage" value="process" />

	<fieldset class="options">
		<legend><?php _e('Options', 'wpai') ?></legend>
<?php if(bb_get_option('ai_dontshowinstr', "no") != "yes"){ ?>
	<b>How to Use</b><br>
	<ul>
	<li>Get a Google Adsense account, a Yahoo Publisher's Network account, or both.</li>
	<li>Select which Ad Network you want to run on your blog.</li>
	<li>Enter your account details in the boxes below.</li>
  <li><input name=dontshowinstr type=checkbox>Don't show these instructions anymore.</li>
  <?php } ?>
		<table width="100%" cellspacing="2" cellpadding="5" class="editform" > 
		  <tr align="left" valign="top">
    <tr valign="top">
			<th width="30%" scope="row" style="text-align: left"><?php _e('Ad Network', 'wpai') ?></th>
      <td>
      <select name='ai_network'>
      <option value="random" <?php if($adnetwork == 'random') echo "SELECTED"; ?> >random
      <option value="YPN" <?php if($adnetwork == 'YPN') echo "SELECTED"; ?> >YPN
      <option value="Adsense" <?php if($adnetwork == 'Adsense') echo "SELECTED"; ?> >Adsense
      </select></td> 
      <td align=right colspan=5>
      <input type="submit" name="action" value="<?php _e('Save', 'wpai') ?>" />
      </td>
    <tr>
			<th width="30%" scope="row" style="text-align: left"><?php _e('Adsense ID', 'wpai') ?></th>
			<td><input type="text" name="ai_client" id="ai_client" style="width: 80%;" cols="50" value="<?php echo $ad_client; ?>"></td></tr>
		  <tr align="left" valign="top">
			<th width="30%" scope="row" style="text-align: left"><?php _e('Adsense Channel', 'wpai') ?></th>
			<td><input type="text" name="ai_channel" id="ai_channel" style="width: 80%;" cols="50" value="<?php echo $ad_channel ; ?>"></td></tr>
		  <tr align="left" valign="top">
			<th width="30%" scope="row" style="text-align: left"><?php _e('YPN Partner ID', 'wpai') ?></th>
			<td><input type="text" name="ai_client_ypn" id="ai_client_ypn" style="width: 80%;" cols="50" value="<?php echo $ad_client_ypn; ?>"> (Optional)</td></tr>
		  <tr align="left" valign="top">
			<th width="30%" scope="row" style="text-align: left"><?php _e('YPN Section (Channel)', 'wpai') ?></th>
			<td><input type="text" name="ai_channel_ypn" id="ai_channel_ypn" style="width: 80%;" cols="50" value="<?php echo $ad_channel_ypn ; ?>"> (Optional)</td></tr>
		  <tr valign="top">
			<th width="30%" scope="row" style="text-align: left"><?php _e('Ad Formats To Randomize', 'wpai') ?></th>

			<td>
			<INPUT TYPE=CHECKBOX NAME="125x125" <?php echo bb_get_option('ai_125x125'); ?>>125x125<BR>
			<INPUT TYPE=CHECKBOX NAME="180x150" <?php echo bb_get_option('ai_180x150'); ?>>180x150<BR>
			<INPUT TYPE=CHECKBOX NAME="120x240" <?php echo bb_get_option('ai_120x240'); ?>>120x240<BR>
			<INPUT TYPE=CHECKBOX NAME="234x60" <?php echo bb_get_option('ai_234x60'); ?>>234x60<BR>
			<INPUT TYPE=CHECKBOX NAME="200x200" <?php echo bb_get_option('ai_200x200'); ?>>200x200<BR>
			<INPUT TYPE=CHECKBOX NAME="250x250" <?php echo bb_get_option('ai_250x250'); ?>>250x250<BR>
			<INPUT TYPE=CHECKBOX NAME="300x250" <?php echo bb_get_option('ai_300x250'); ?>>300x250<BR>
			<INPUT TYPE=CHECKBOX NAME="336x280" <?php echo bb_get_option('ai_336x280'); ?>>336x280<BR>
			<INPUT TYPE=CHECKBOX NAME="468x60" <?php echo bb_get_option('ai_468x60'); ?>>468x60<BR>
      </td>
      </tr>
      
      <tr align="left" valign="top">
        <th width="30%" scope="row" style="text-align: left"><?php _e('Colors', 'wpai') ?></th>
            <td>
			<table><tr><td>Color Border:</td><td><input type="text" name="ai_color_border" id="ai_color_border" cols="50" value="<?php echo $ai_color_border; ?>"></td></tr>
			<tr><td>Color Link:</td><td><input type="text" name="ai_color_link" id="ai_color_link" cols="50" value="<?php echo $ai_color_link; ?>"></td></tr>
			<tr><td>Color Background:</td><td><input type="text" name="ai_color_bg" id="ai_color_bg" cols="50" value="<?php echo $ai_color_bg; ?>"></td></tr>
			<tr><td>Color Text:</td><td><input type="text" name="ai_color_text" id="ai_color_text" cols="50" value="<?php echo $ai_color_text; ?>"></td></tr>
			<tr><td>Color URL:</td><td><input type="text" name="ai_color_url" id="ai_color_url" cols="50" value="<?php echo $ai_color_url; ?>"></td></tr>
			</tr></table>
			</td></tr>
	
		<tr valign="top">
			<th width="30%" scope="row" style="text-align: left"><?php _e('Number of Ads to Show', 'wpai') ?></th>
      <td>
      <select name='nads'>
      <option value="0" <?php if($nads == 0) echo "SELECTED"; ?> >0
      <option value="1" <?php if($nads == 1) echo "SELECTED"; ?> >1
      <option value="2" <?php if($nads == 2) echo "SELECTED"; ?> >2
      <option value="3" <?php if($nads == 3) echo "SELECTED"; ?> >3
      </select>

      </td> 
    </tr>
    
    <tr valign="top">
			<th width="30%" scope="row" style="text-align: left"><?php _e('Ad Positioning', 'wpai') ?></th>
      <td>
      <select name='ai_pos'>
      <option value="random" <?php if($lra == 'random') echo "SELECTED"; ?> >random
      <option value="left" <?php if($lra == 'left') echo "SELECTED"; ?> >left
      <option value="right" <?php if($lra == 'right') echo "SELECTED"; ?> >right
      <option value="center" <?php if($lra == 'center') echo "SELECTED"; ?> >center
      </select></td> 
    <tr>
    <td colspan=5><input name=betatest type=checkbox <?php if(bb_get_option("ai_betatest") == "yes") echo "checked"; ?>>Only let me see the ads!</td>
    </tr><tr>
    <td colspan=5><input name=notme type=checkbox <?php if(bb_get_option("ai_notme") == "yes") echo "checked"; ?>>Don't make me see the ads! (What am I, a reader?)</td>
    </tr><tr>
    <td colspan=5><input name=googtestmode type=checkbox <?php if(bb_get_option("ai_googtestmode") == "yes") echo "checked"; ?>>Insert google_adtest="on"; when I'm looking at my own blog.</td>
    </tr>

    <tr>
      <td align=right colspan=5>
      <input type="submit" name="action" value="<?php _e('Save', 'wpai') ?>" />
      </td>
    </tr>
    </table>
	</fieldset>
	
	 
  </form> 
</div>
<?php 

}

add_action('admin_menu', 'ai_add_options');

function ai_install() {

  if(bb_get_option('ai_client') == "") {
    bb_update_option('ai_network', "Adsense");
    bb_update_option('ai_lra', "random");
    bb_update_option('ai_nads', 3);
    bb_update_option('ai_text_only', false);
  }
}
if (isset($_GET['activate']) && $_GET['activate'] == 'true') {
   add_action('init', 'ai_install');
}


function ai_pickalign($tag){
  $size = ai_picksize();
  $width = substr($size, 0, 3);
  $height = substr($size, 4, 3);
  if($tag == "left")
    return '<div style="margin:1em 7px 2px 0px; float:left; text-indent:0px; width:$width px; height:$height px">';
  if($tag == "right")
    return '<div style="margin:1em 0px 2px 7px; float:right; text-indent:0px;width:$width px; height:$height px">';
  if($tag == "center")
    return '<div style="text-align: center;text-indent:0px">';
  else
    return ai_pickalign(rand(0,10)<5?"left":"right");
}

function ai_picksize(){
  $sizes = array();
  if(strlen(bb_get_option('ai_234x60'))) $sizes[] = "234x60";
  if(strlen(bb_get_option('ai_200x200'))) $sizes[] = "200x200";
  if(strlen(bb_get_option('ai_125x125')))
    $sizes[] = "125x125";
  if(strlen(bb_get_option('ai_180x150')))
    $sizes[] = "180x150";
  if(strlen(bb_get_option('ai_120x240')))
    $sizes[] = "120x240";
  if(strlen(bb_get_option('ai_300x250')))
    $sizes[] = "300x250";
  if(strlen(bb_get_option('ai_250x250')))
    $sizes[] = "250x250";
  if(strlen(bb_get_option('ai_468x60')))
    $sizes[] = "468x60";
  if(strlen(bb_get_option('ai_336x280')))
    $sizes[] = "336x280"; // addition by K2xL.com

  return $sizes[rand(0, sizeof($sizes)-1)];
}

//you can only show one network at a time.
$ai_loadnetwork = "";

function ai_genadcode(){
  global $bb_current_user, $ai_loadnetwork;
  $size = ai_picksize();
  $width = substr($size, 0, 3);
  $height = substr($size, 4, 3);
    
  $client = bb_get_option('ai_client');
  $channel = bb_get_option('ai_channel');
  $client_ypn = bb_get_option('ai_client_ypn');
  $channel_ypn = bb_get_option('ai_channel_ypn');
  
  $color_border = bb_get_option('ai_color_border');
  $color_link = bb_get_option('ai_color_link');
  $color_bg = bb_get_option('ai_color_bg');
  $color_text = bb_get_option('ai_color_text');
  $color_url = bb_get_option('ai_color_url');
  
  $retstr = "";
  $adnetwork = $ai_loadnetwork;
  if($adnetwork == "")
    $adnetwork = bb_get_option("ai_network", "Adsense");
  if($adnetwork == "random"){
    $adnetwork = (rand(0,1)==0?"YPN":"Adsense");
  }
  $ai_loadnetwork = $adnetwork;
  if($adnetwork == "YPN"){
    $retstr = '<script language="JavaScript">
<!--
ctxt_ad_partner = "'.$client_ypn.'";
ctxt_ad_section = "'.$channel_ypn.'";
ctxt_ad_bg = "";
ctxt_ad_width = '.$width.';
ctxt_ad_height = '.$height.';
ctxt_ad_bc = "'.$color_bg.'";
ctxt_ad_cc = "'.$color_border.'";
ctxt_ad_lc = "'.$color_link.'";
ctxt_ad_tc = "'.$color_text.'";
ctxt_ad_uc = "'.$color_url.'";
// -->
</script>
<script language="JavaScript" src="http://ypn-js.overture.com/partner/js/ypn.js">

</script>';

  }
  else{
    $retstr = '<script type="text/javascript"><!--
';
  if(bb_get_option('ai_googtestmode') == "yes" && bb_current_user_can( 'use_keys' ))
    $retstr .= 'google_adtest="on";
';

  $retstr .= 'google_ad_client = "'.$client.'";
google_alternate_color = "FFFFFF";
google_ad_width = '.$width.';
google_ad_height = '.$height.';
google_ad_format = "'.$size.'_as";
google_ad_type = "text_image";
google_ad_channel ="'.$channel.'";
google_color_border = "'.$color_border.'";
google_color_link = "'.$color_link.'";
google_color_bg = "'.$color_bg.'";
google_color_text = "'.$color_text.'";
google_color_url = "'.$color_url.'";
//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script>';
  }

  return $retstr;
}

$ai_adsused = 0;

function bbai_the_content($content){
  global $bb_alt, $ai_adsused, $bb_current_user;
  
  if(bb_get_option('ai_betatest') == "yes" && !(bb_current_user_can(  'use_keys' )))
    return $content;
  if(bb_get_option('ai_notme') == "yes" && bb_current_user_can( 'use_keys'))
    return $content;

  $numads = bb_get_option('ai_nads');
  
  $content_hold = "";
  
  if($ai_adsused < $numads && ($bb_alt['post']%2 == 0))
  {
    $adsperpost = $ai_adsused+1;
  
    $replacewith = ai_pickalign(bb_get_option('ai_lra'));
    $replacewith .= ai_genadcode()."</div>".$bb_current_user->capabilities ;
    
    $content = $replacewith.$content;
    $ai_adsused++;
  }

  return $content;
}

add_filter('post_text', 'bbai_the_content');

?>